package jedi.example;

public class CommandExampleStaticClosureFactory {
	private static ICommandExampleClosureFactory $DELEGATE = new CommandExampleClosureFactory();

	public static void setDelegate(ICommandExampleClosureFactory newDelegate) {
		jedi.assertion.Assert.assertNotNull(newDelegate, "newDelegate must not be null");
		$DELEGATE = newDelegate;
	}

	public static void useDefaultDelegate() {
		setDelegate(new CommandExampleClosureFactory());
	}
	/**
	 * @see jedi.example.CommandExample#doX
	 */
	public static  jedi.functional.Command<jedi.example.CommandExample> doXCommand(final java.lang.String arg) {
		return $DELEGATE.doXCommand(arg);
	}
	/**
	 * @see jedi.example.CommandExample#doX
	 */
	public static  jedi.functional.Command<java.lang.String> doXProxyCommand(final jedi.example.CommandExample $receiver) {
		return $DELEGATE.doXProxyCommand($receiver);
	}
	/**
	 * @see jedi.example.CommandExample#doY
	 */
	public static  jedi.functional.Command<jedi.example.CommandExample> doYCommand() {
		return $DELEGATE.doYCommand();
	}
	/**
	 * @see jedi.example.CommandExample#doY
	 */
	public static  jedi.functional.Command0 doYProxyCommand0(final jedi.example.CommandExample $receiver) {
		return $DELEGATE.doYProxyCommand0($receiver);
	}
}
